#ifndef MOTEUR_SIMULATEUR
#define MOTEUR_SIMULATEUR

#include "moteur_simulateur.h"
#include "gst_ual.h"
#include "gst_cond.h"
#include "gst_decodeur.h"
#include "gst_micro_mem.h"
#include "gst_cp.h"
#include "gst_controleur_bus.h"
#include "gst_mem_principale.h"
#include "gst_micro_cp.h"
#include "gst_reg.h"
#include "gst_bus.h"
#include "gst_eval_grp.h"

#define FIL int
#define NBRE_MOP 26
#define TAILLE_MP 256
#define TAILLE_MM 64
#define TAILLE_DECI 32
#define FICHIER_MM "micro-memory"
#define FICHIER_MP "main-memory"
#define FICHIER_DECI "instruction-decoder"

typedef struct mtr_infos
{
  int *mop;
  int *mp;
  int *deci;
  int **mm;
  int *valeur_bus_donnees;
  int *valeur_bus_adresses;
  int *valeur_bus_cp_cb;
  int *valeur_bus_regad_cb;
  int *valeur_bus_deci_mcp;
  int *valeur_bus_mcp_mm;
  int *valeur_bus_reg0_ual;
  int *valeur_bus_ual_reg1;
  int *valeur_bus_reg1_ual;
  int *valeur_bus_regdonnees_cb;
  int *valeur_bus_pptr_cb;
  FIL *valeur_fil_ual_regcond;
  FIL *valeur_fil_regcond_cond;
  FIL *valeur_fil_cond_cp;
} mtr_infos;
  
/* La structure mtr_infos doit avoir t alloue auparavant */
void mtr_init (mtr_infos *infos);

void mtr_reset_et_charge_memoires (char *nom_fic_mp, char *nom_fic_idec, 
				   char *nom_fic_mm);

void mtr_cycle_suivant ();

void mtr_cycle_precedant ();

void mtr_libere ();

#endif /* MOTEUR_SIMULATEUR */
